// Includes ////////////////////////////////////////////////////////////////

#include "UI.h"

// Functions ///////////////////////////////////////////////////////////////

UI::LightTheme::LightTheme(const Dpi &dpi)
{
	IsDark = false;
	Padding = dpi.Scale(4);
	COLORREF TextColor = RGB(0, 0, 0);
	COLORREF BackgroundColor = RGB(255, 255, 255);
	COLORREF SelectedTextColor = RGB(255, 255, 255);
	COLORREF SelectedBackgroundColor = RGB(0, 120, 215);
	COLORREF WindowTextColor = RGB(0, 0, 0);
	WindowBackgroundColor = RGB(240, 240, 240);
	ButtonTextColor = RGB(0, 0, 0);
	ButtonBackgroundColor = RGB(225, 225, 225);
	ButtonBorderColor = RGB(173, 173, 173);
	ButtonBorderSize = dpi.Scale(1);
	ButtonFocusedTextColor = ButtonTextColor;
	ButtonFocusedBackgroundColor = ButtonBackgroundColor;
	ButtonFocusedBorderColor = SelectedBackgroundColor;
	ButtonFocusedBorderSize = ButtonBorderSize * 2;
	ButtonFocusRect = true;
	ButtonFocusRectPadding = ButtonBorderSize * 2;
	ButtonHoverTextColor = ButtonTextColor;
	ButtonHoverBackgroundColor = RGB(229, 241, 251);
	ButtonHoverBorderColor = SelectedBackgroundColor;
	ButtonHoverBorderSize = ButtonBorderSize;
	ButtonHoverFocusedTextColor = ButtonHoverTextColor;
	ButtonHoverFocusedBackgroundColor = ButtonHoverBackgroundColor;
	ButtonHoverFocusedBorderColor = ButtonHoverBorderColor;
	ButtonHoverFocusedBorderSize = ButtonHoverBorderSize;
	ButtonPushedTextColor = ButtonTextColor;
	ButtonPushedBackgroundColor = RGB(204, 228, 247);
	ButtonPushedBorderColor = RGB(0, 84, 153);
	ButtonPushedBorderSize = ButtonBorderSize;
	ButtonDisabledTextColor = RGB(131, 131, 131);
	ButtonDisabledBackgroundColor = RGB(204, 204, 204);
	ButtonDisabledBorderColor = RGB(191, 191, 191);
	ButtonDisabledBorderSize = ButtonBorderSize;
	ListBoxPaddingSize = ButtonBorderSize;
	ListBoxTextColor = TextColor;
	ListBoxBackgroundColor = BackgroundColor;
	ListBoxSelectedTextColor = SelectedTextColor;
	ListBoxSelectedBackgroundColor = SelectedBackgroundColor;
	ListBoxGrayTextColor = ButtonDisabledTextColor;
	ListBoxGrayBackgroundColor = ListBoxBackgroundColor;
	ListBoxGraySelectedTextColor = ButtonDisabledBackgroundColor;
	ListBoxGraySelectedBackgroundColor = ButtonDisabledTextColor;
	ListBoxBorderColor = ButtonBorderColor;
	ListBoxBorderSize = ButtonBorderSize;
	ListBoxFocusedBorderColor = ListBoxBorderColor;
	ListBoxFocusedBorderSize = ListBoxBorderSize;
	ListBoxFocusRect = true;
	ListBoxFocusRectPadding = 0;
	ListBoxHoverBorderColor = ListBoxBorderColor;
	ListBoxHoverBorderSize = ListBoxBorderSize;
	ListBoxHoverFocusedBorderColor = ListBoxFocusedBorderColor;
	ListBoxHoverFocusedBorderSize = ListBoxFocusedBorderSize;
	ListBoxDisabledTextColor = ButtonDisabledTextColor;
	ListBoxDisabledBackgroundColor = ButtonDisabledBackgroundColor;
	ListBoxDisabledBorderColor = ButtonDisabledBorderColor;
	ListBoxDisabledBorderSize = ButtonDisabledBorderSize;
	ComboBoxButtonWidth = dpi.GetSystemMetrics(SM_CXVSCROLL);
	ComboBoxTextColor = ButtonTextColor;
	ComboBoxBackgroundColor = ButtonBackgroundColor;
	ComboBoxBorderColor = ButtonBorderColor;
	ComboBoxBorderSize = ButtonBorderSize;
	ComboBoxFocusedTextColor = ButtonFocusedTextColor;
	ComboBoxFocusedBackgroundColor = ButtonFocusedBackgroundColor;
	ComboBoxFocusedBorderColor = ComboBoxBorderColor;
	ComboBoxFocusedBorderSize = ComboBoxBorderSize;
	ComboBoxFocusRect = true;
	ComboBoxFocusRectPadding = Padding - 1;
	ComboBoxHoverTextColor = ButtonHoverTextColor;
	ComboBoxHoverBackgroundColor = ButtonHoverBackgroundColor;
	ComboBoxHoverBorderColor = ButtonHoverBorderColor;
	ComboBoxHoverBorderSize = ButtonHoverBorderSize;
	ComboBoxHoverFocusedTextColor = ComboBoxHoverTextColor;
	ComboBoxHoverFocusedBackgroundColor = ComboBoxHoverBackgroundColor;
	ComboBoxHoverFocusedBorderColor = ComboBoxHoverBorderColor;
	ComboBoxHoverFocusedBorderSize = ComboBoxHoverBorderSize;
	ComboBoxPushedTextColor = ButtonPushedTextColor;
	ComboBoxPushedBackgroundColor = ButtonPushedBackgroundColor;
	ComboBoxPushedBorderColor = ButtonPushedBorderColor;
	ComboBoxPushedBorderSize = ButtonPushedBorderSize;
	ComboBoxDisabledTextColor = ButtonDisabledTextColor;
	ComboBoxDisabledBackgroundColor = ButtonDisabledBackgroundColor;
	ComboBoxDisabledBorderColor = ButtonDisabledBorderColor;
	ComboBoxDisabledBorderSize = ButtonDisabledBorderSize;
	ComboBoxListTextColor = ListBoxTextColor;
	ComboBoxListBackgroundColor = ListBoxBackgroundColor;
	ComboBoxListSelectedTextColor = ListBoxSelectedTextColor;
	ComboBoxListSelectedBackgroundColor = ListBoxSelectedBackgroundColor;
	ComboBoxListGrayTextColor = ListBoxGrayTextColor;
	ComboBoxListGrayBackgroundColor = ListBoxGrayBackgroundColor;
	ComboBoxListGraySelectedTextColor = ListBoxGraySelectedTextColor;
	ComboBoxListGraySelectedBackgroundColor = ListBoxGraySelectedBackgroundColor;
	ComboBoxListFocusRect = ListBoxFocusRect;
	ComboBoxListFocusRectPadding = ListBoxFocusRectPadding;
	GroupBoxTextColor = WindowTextColor;
	GroupBoxBackgroundColor = WindowBackgroundColor;
	GroupBoxBorderColor = ButtonBorderColor;
	GroupBoxBorderSize = ButtonBorderSize;
	GroupBoxDisabledTextColor = ButtonDisabledTextColor;
	GroupBoxDisabledBackgroundColor = GroupBoxBackgroundColor;
	GroupBoxDisabledBorderColor = ButtonDisabledBorderColor;
	GroupBoxDisabledBorderSize = ButtonDisabledBorderSize;
	LabelTextColor = WindowTextColor;
	LabelBackgroundColor = WindowBackgroundColor;
	LabelDisabledTextColor = ButtonDisabledTextColor;
	LabelDisabledBackgroundColor = LabelBackgroundColor;
	TextBoxTextColor = TextColor;
	TextBoxBackgroundColor = BackgroundColor;
	TextBoxInvalidTextColor = RGB(255, 0, 0);
	TextBoxInvalidBackgroundColor = TextBoxBackgroundColor;
	TextBoxBorderColor = ButtonBorderColor;
	TextBoxBorderSize = ButtonBorderSize;
	TextBoxFocusedBorderColor = ButtonFocusedBorderColor;
	TextBoxFocusedBorderSize = TextBoxBorderSize;
	TextBoxHoverBorderColor = RGB(23, 23, 23);
	TextBoxHoverBorderSize = TextBoxBorderSize;
	TextBoxHoverFocusedBorderColor = TextBoxFocusedBorderColor;
	TextBoxHoverFocusedBorderSize = TextBoxFocusedBorderSize;
	TextBoxDisabledTextColor = ButtonDisabledTextColor;
	TextBoxDisabledBackgroundColor = ButtonDisabledBackgroundColor;
	TextBoxDisabledBorderColor = ButtonDisabledBorderColor;
	TextBoxDisabledBorderSize = ButtonDisabledBorderSize;
}

////////////////////////////////////////////////////////////////////////////

UI::DarkTheme::DarkTheme(const Dpi &dpi)
{
	IsDark = true;
	Padding = dpi.Scale(4);
	COLORREF TextColor = RGB(255, 255, 255);
	COLORREF BackgroundColor = RGB(0, 0, 0);
	COLORREF SelectedTextColor = RGB(255, 255, 255);
	COLORREF SelectedBackgroundColor = RGB(0, 120, 215);
	COLORREF WindowTextColor = RGB(255, 255, 255);
	WindowBackgroundColor = RGB(0, 0, 0);
	ButtonTextColor = RGB(255, 255, 255);
	ButtonBackgroundColor = RGB(51, 51, 51);
	ButtonBorderColor = RGB(155, 155, 155);
	ButtonBorderSize = dpi.Scale(1);
	ButtonFocusedTextColor = ButtonTextColor;
	ButtonFocusedBackgroundColor = ButtonBackgroundColor;
	ButtonFocusedBorderColor = RGB(255, 255, 255);
	ButtonFocusedBorderSize = ButtonBorderSize;
	ButtonFocusRect = true;
	ButtonFocusRectPadding = ButtonBorderSize * 2;
	ButtonHoverTextColor = ButtonTextColor;
	ButtonHoverBackgroundColor = RGB(69, 69, 69);
	ButtonHoverBorderColor = ButtonBorderColor;
	ButtonHoverBorderSize = ButtonBorderSize;
	ButtonHoverFocusedTextColor = ButtonHoverTextColor;
	ButtonHoverFocusedBackgroundColor = ButtonHoverBackgroundColor;
	ButtonHoverFocusedBorderColor = ButtonHoverBorderColor;
	ButtonHoverFocusedBorderSize = ButtonHoverBorderSize;
	ButtonPushedTextColor = ButtonTextColor;
	ButtonPushedBackgroundColor = RGB(102, 102, 102);
	ButtonPushedBorderColor = ButtonBorderColor;
	ButtonPushedBorderSize = ButtonBorderSize;
	ButtonDisabledTextColor = RGB(131, 131, 131);
	ButtonDisabledBackgroundColor = RGB(51, 51, 51);
	ButtonDisabledBorderColor = RGB(64, 64, 64);
	ButtonDisabledBorderSize = ButtonBorderSize;
	ListBoxPaddingSize = ButtonBorderSize;
	ListBoxTextColor = TextColor;
	ListBoxBackgroundColor = BackgroundColor;
	ListBoxSelectedTextColor = SelectedTextColor;
	ListBoxSelectedBackgroundColor = SelectedBackgroundColor;
	ListBoxGrayTextColor = ButtonDisabledTextColor;
	ListBoxGrayBackgroundColor = ListBoxBackgroundColor;
	ListBoxGraySelectedTextColor = ButtonDisabledBackgroundColor;
	ListBoxGraySelectedBackgroundColor = ButtonDisabledTextColor;
	ListBoxBorderColor = ButtonBorderColor;
	ListBoxBorderSize = ButtonBorderSize;
	ListBoxFocusedBorderColor = ListBoxBorderColor;
	ListBoxFocusedBorderSize = ListBoxBorderSize;
	ListBoxFocusRect = true;
	ListBoxFocusRectPadding = 0;
	ListBoxHoverBorderColor = ListBoxBorderColor;
	ListBoxHoverBorderSize = ListBoxBorderSize;
	ListBoxHoverFocusedBorderColor = ListBoxFocusedBorderColor;
	ListBoxHoverFocusedBorderSize = ListBoxFocusedBorderSize;
	ListBoxDisabledTextColor = ButtonDisabledTextColor;
	ListBoxDisabledBackgroundColor = ButtonDisabledBackgroundColor;
	ListBoxDisabledBorderColor = ButtonDisabledBorderColor;
	ListBoxDisabledBorderSize = ButtonDisabledBorderSize;
	ComboBoxButtonWidth = dpi.GetSystemMetrics(SM_CXVSCROLL);
	ComboBoxTextColor = ButtonTextColor;
	ComboBoxBackgroundColor = ButtonBackgroundColor;
	ComboBoxBorderColor = ButtonBorderColor;
	ComboBoxBorderSize = ButtonBorderSize;
	ComboBoxFocusedTextColor = ButtonFocusedTextColor;
	ComboBoxFocusedBackgroundColor = ButtonFocusedBackgroundColor;
	ComboBoxFocusedBorderColor = ComboBoxBorderColor;
	ComboBoxFocusedBorderSize = ComboBoxBorderSize;
	ComboBoxFocusRect = true;
	ComboBoxFocusRectPadding = Padding - 1;
	ComboBoxHoverTextColor = ButtonHoverTextColor;
	ComboBoxHoverBackgroundColor = ButtonHoverBackgroundColor;
	ComboBoxHoverBorderColor = ButtonHoverBorderColor;
	ComboBoxHoverBorderSize = ButtonHoverBorderSize;
	ComboBoxHoverFocusedTextColor = ComboBoxHoverTextColor;
	ComboBoxHoverFocusedBackgroundColor = ComboBoxHoverBackgroundColor;
	ComboBoxHoverFocusedBorderColor = ComboBoxHoverBorderColor;
	ComboBoxHoverFocusedBorderSize = ComboBoxHoverBorderSize;
	ComboBoxPushedTextColor = ButtonPushedTextColor;
	ComboBoxPushedBackgroundColor = ButtonPushedBackgroundColor;
	ComboBoxPushedBorderColor = ButtonPushedBorderColor;
	ComboBoxPushedBorderSize = ButtonPushedBorderSize;
	ComboBoxDisabledTextColor = ButtonDisabledTextColor;
	ComboBoxDisabledBackgroundColor = ButtonDisabledBackgroundColor;
	ComboBoxDisabledBorderColor = ButtonDisabledBorderColor;
	ComboBoxDisabledBorderSize = ButtonDisabledBorderSize;
	ComboBoxListTextColor = ListBoxTextColor;
	ComboBoxListBackgroundColor = ListBoxBackgroundColor;
	ComboBoxListSelectedTextColor = ListBoxSelectedTextColor;
	ComboBoxListSelectedBackgroundColor = ListBoxSelectedBackgroundColor;
	ComboBoxListGrayTextColor = ListBoxGrayTextColor;
	ComboBoxListGrayBackgroundColor = ListBoxGrayBackgroundColor;
	ComboBoxListGraySelectedTextColor = ListBoxGraySelectedTextColor;
	ComboBoxListGraySelectedBackgroundColor = ListBoxGraySelectedBackgroundColor;
	ComboBoxListFocusRect = ListBoxFocusRect;
	ComboBoxListFocusRectPadding = ListBoxFocusRectPadding;
	GroupBoxTextColor = WindowTextColor;
	GroupBoxBackgroundColor = WindowBackgroundColor;
	GroupBoxBorderColor = ButtonBorderColor;
	GroupBoxBorderSize = ButtonBorderSize;
	GroupBoxDisabledTextColor = ButtonDisabledTextColor;
	GroupBoxDisabledBackgroundColor = GroupBoxBackgroundColor;
	GroupBoxDisabledBorderColor = ButtonDisabledBorderColor;
	GroupBoxDisabledBorderSize = ButtonDisabledBorderSize;
	LabelTextColor = WindowTextColor;
	LabelBackgroundColor = WindowBackgroundColor;
	LabelDisabledTextColor = ButtonDisabledTextColor;
	LabelDisabledBackgroundColor = LabelBackgroundColor;
	TextBoxTextColor = TextColor;
	TextBoxBackgroundColor = BackgroundColor;
	TextBoxInvalidTextColor = RGB(255, 0, 0);
	TextBoxInvalidBackgroundColor = TextBoxBackgroundColor;
	TextBoxBorderColor = ButtonBorderColor;
	TextBoxBorderSize = ButtonBorderSize;
	TextBoxFocusedBorderColor = ButtonFocusedBorderColor;
	TextBoxFocusedBorderSize = TextBoxBorderSize;
	TextBoxHoverBorderColor = RGB(200, 200, 200);
	TextBoxHoverBorderSize = TextBoxBorderSize;
	TextBoxHoverFocusedBorderColor = TextBoxFocusedBorderColor;
	TextBoxHoverFocusedBorderSize = TextBoxFocusedBorderSize;
	TextBoxDisabledTextColor = ButtonDisabledTextColor;
	TextBoxDisabledBackgroundColor = ButtonDisabledBackgroundColor;
	TextBoxDisabledBorderColor = ButtonDisabledBorderColor;
	TextBoxDisabledBorderSize = ButtonDisabledBorderSize;
}

////////////////////////////////////////////////////////////////////////////

UI::HighContrastTheme::HighContrastTheme(const Dpi &dpi)
{
	IsDark = false;
	Padding = dpi.Scale(4);
	COLORREF TextColor = GetSysColor(COLOR_WINDOWTEXT);
	COLORREF BackgroundColor = GetSysColor(COLOR_WINDOW);
	COLORREF SelectedTextColor = GetSysColor(COLOR_HIGHLIGHTTEXT);
	COLORREF SelectedBackgroundColor = GetSysColor(COLOR_HIGHLIGHT);
	COLORREF WindowTextColor = GetSysColor(COLOR_BTNTEXT);
	WindowBackgroundColor = GetSysColor(COLOR_BTNFACE);
	ButtonTextColor = GetSysColor(COLOR_BTNTEXT);
	ButtonBackgroundColor = GetSysColor(COLOR_BTNFACE);
	ButtonBorderColor = GetSysColor(COLOR_BTNTEXT);
	ButtonBorderSize = dpi.Scale(1);
	ButtonFocusedTextColor = SelectedTextColor;
	ButtonFocusedBackgroundColor = SelectedBackgroundColor;
	ButtonFocusedBorderColor = ButtonBorderColor;
	ButtonFocusedBorderSize = ButtonBorderSize;
	ButtonFocusRect = true;
	ButtonFocusRectPadding = ButtonBorderSize * 2;
	ButtonHoverTextColor = SelectedTextColor;
	ButtonHoverBackgroundColor = SelectedBackgroundColor;
	ButtonHoverBorderColor = ButtonBorderColor;
	ButtonHoverBorderSize = ButtonBorderSize;
	ButtonHoverFocusedTextColor = ButtonHoverTextColor;
	ButtonHoverFocusedBackgroundColor = ButtonHoverBackgroundColor;
	ButtonHoverFocusedBorderColor = ButtonHoverBorderColor;
	ButtonHoverFocusedBorderSize = ButtonHoverBorderSize;
	ButtonPushedTextColor = ButtonTextColor;
	ButtonPushedBackgroundColor = ButtonBackgroundColor;
	ButtonPushedBorderColor = ButtonBorderColor;
	ButtonPushedBorderSize = ButtonBorderSize;
	ButtonDisabledTextColor = GetSysColor(COLOR_GRAYTEXT);
	ButtonDisabledBackgroundColor = ButtonBackgroundColor;
	ButtonDisabledBorderColor = GetSysColor(COLOR_GRAYTEXT);
	ButtonDisabledBorderSize = ButtonBorderSize;
	ListBoxPaddingSize = ButtonBorderSize;
	ListBoxTextColor = TextColor;
	ListBoxBackgroundColor = BackgroundColor;
	ListBoxSelectedTextColor = SelectedTextColor;
	ListBoxSelectedBackgroundColor = SelectedBackgroundColor;
	ListBoxGrayTextColor = ButtonDisabledTextColor;
	ListBoxGrayBackgroundColor = ListBoxBackgroundColor;
	ListBoxGraySelectedTextColor = ButtonDisabledBackgroundColor;
	ListBoxGraySelectedBackgroundColor = ButtonDisabledTextColor;
	ListBoxBorderColor = ButtonBorderColor;
	ListBoxBorderSize = ButtonBorderSize;
	ListBoxFocusedBorderColor = ListBoxBorderColor;
	ListBoxFocusedBorderSize = ListBoxBorderSize;
	ListBoxFocusRect = true;
	ListBoxFocusRectPadding = 0;
	ListBoxHoverBorderColor = ListBoxBorderColor;
	ListBoxHoverBorderSize = ListBoxBorderSize;
	ListBoxHoverFocusedBorderColor = ListBoxFocusedBorderColor;
	ListBoxHoverFocusedBorderSize = ListBoxFocusedBorderSize;
	ListBoxDisabledTextColor = ButtonDisabledTextColor;
	ListBoxDisabledBackgroundColor = ButtonDisabledBackgroundColor;
	ListBoxDisabledBorderColor = ButtonDisabledBorderColor;
	ListBoxDisabledBorderSize = ButtonDisabledBorderSize;
	ComboBoxButtonWidth = dpi.GetSystemMetrics(SM_CXVSCROLL);
	ComboBoxTextColor = ButtonTextColor;
	ComboBoxBackgroundColor = ButtonBackgroundColor;
	ComboBoxBorderColor = ButtonBorderColor;
	ComboBoxBorderSize = ButtonBorderSize;
	ComboBoxFocusedTextColor = ComboBoxTextColor;
	ComboBoxFocusedBackgroundColor = ComboBoxBackgroundColor;
	ComboBoxFocusedBorderColor = ComboBoxBorderColor;
	ComboBoxFocusedBorderSize = ComboBoxBorderSize;
	ComboBoxFocusRect = true;
	ComboBoxFocusRectPadding = Padding - 1;
	ComboBoxHoverTextColor = ComboBoxTextColor;
	ComboBoxHoverBackgroundColor = ComboBoxBackgroundColor;
	ComboBoxHoverBorderColor = GetSysColor(COLOR_HOTLIGHT);
	ComboBoxHoverBorderSize = ComboBoxBorderSize;
	ComboBoxHoverFocusedTextColor = ComboBoxHoverTextColor;
	ComboBoxHoverFocusedBackgroundColor = ComboBoxHoverBackgroundColor;
	ComboBoxHoverFocusedBorderColor = ComboBoxHoverBorderColor;
	ComboBoxHoverFocusedBorderSize = ComboBoxHoverBorderSize;
	ComboBoxPushedTextColor = ComboBoxTextColor;
	ComboBoxPushedBackgroundColor = ComboBoxBackgroundColor;
	ComboBoxPushedBorderColor = GetSysColor(COLOR_HOTLIGHT);
	ComboBoxPushedBorderSize = ComboBoxBorderSize;
	ComboBoxDisabledTextColor = ButtonDisabledTextColor;
	ComboBoxDisabledBackgroundColor = ButtonDisabledBackgroundColor;
	ComboBoxDisabledBorderColor = ButtonDisabledBorderColor;
	ComboBoxDisabledBorderSize = ButtonDisabledBorderSize;
	ComboBoxListTextColor = ListBoxTextColor;
	ComboBoxListBackgroundColor = ListBoxBackgroundColor;
	ComboBoxListSelectedTextColor = ListBoxSelectedTextColor;
	ComboBoxListSelectedBackgroundColor = ListBoxSelectedBackgroundColor;
	ComboBoxListGrayTextColor = ListBoxGrayTextColor;
	ComboBoxListGrayBackgroundColor = ListBoxGrayBackgroundColor;
	ComboBoxListGraySelectedTextColor = ListBoxGraySelectedTextColor;
	ComboBoxListGraySelectedBackgroundColor = ListBoxGraySelectedBackgroundColor;
	ComboBoxListFocusRect = ListBoxFocusRect;
	ComboBoxListFocusRectPadding = ListBoxFocusRectPadding;
	GroupBoxTextColor = WindowTextColor;
	GroupBoxBackgroundColor = WindowBackgroundColor;
	GroupBoxBorderColor = ButtonBorderColor;
	GroupBoxBorderSize = ButtonBorderSize;
	GroupBoxDisabledTextColor = ButtonDisabledTextColor;
	GroupBoxDisabledBackgroundColor = GroupBoxBackgroundColor;
	GroupBoxDisabledBorderColor = ButtonDisabledBorderColor;
	GroupBoxDisabledBorderSize = ButtonDisabledBorderSize;
	LabelTextColor = WindowTextColor;
	LabelBackgroundColor = WindowBackgroundColor;
	LabelDisabledTextColor = ButtonDisabledTextColor;
	LabelDisabledBackgroundColor = LabelBackgroundColor;
	TextBoxTextColor = TextColor;
	TextBoxBackgroundColor = BackgroundColor;
	TextBoxInvalidTextColor = RGB(255, 0, 0);
	TextBoxInvalidBackgroundColor = TextBoxBackgroundColor;
	TextBoxBorderColor = ButtonBorderColor;
	TextBoxBorderSize = ButtonBorderSize;
	TextBoxFocusedBorderColor = GetSysColor(COLOR_HOTLIGHT);
	TextBoxFocusedBorderSize = TextBoxBorderSize;
	TextBoxHoverBorderColor = GetSysColor(COLOR_HOTLIGHT);
	TextBoxHoverBorderSize = TextBoxBorderSize;
	TextBoxHoverFocusedBorderColor = TextBoxFocusedBorderColor;
	TextBoxHoverFocusedBorderSize = TextBoxFocusedBorderSize;
	TextBoxDisabledTextColor = ButtonDisabledTextColor;
	TextBoxDisabledBackgroundColor = ButtonDisabledBackgroundColor;
	TextBoxDisabledBorderColor = ButtonDisabledBorderColor;
	TextBoxDisabledBorderSize = ButtonDisabledBorderSize;
}

////////////////////////////////////////////////////////////////////////////
